using System;
using System.Collections.Generic;
using System.Text;
using System.Security.Cryptography;
using System.Collections;

namespace CSockets
{
    public static class Encryption
    {
        public static byte[] Encrypt(byte[] bytes, int dwKeySize, String PublicKeyXml)
        {
            if (PublicKeyXml == null)
            {
                return bytes;
            }
            else
            {
                RSACryptoServiceProvider rsaCryptoServiceProvider = new RSACryptoServiceProvider(dwKeySize);
                rsaCryptoServiceProvider.FromXmlString(PublicKeyXml);
                int keySize = dwKeySize / 8;
                int maxLength = keySize - 42;
                int dataLength = bytes.Length;
                int iterations = dataLength / maxLength;
                StringBuilder stringBuilder = new StringBuilder();
                for (int i = 0; i <= iterations; i++)
                {
                    byte[] tempBytes = new byte[(dataLength - maxLength * i > maxLength) ? maxLength : dataLength - maxLength * i];
                    Buffer.BlockCopy(bytes, maxLength * i, tempBytes, 0, tempBytes.Length);
                    byte[] encryptedBytes = rsaCryptoServiceProvider.Encrypt(tempBytes, false);
                    Array.Reverse(encryptedBytes);
                    stringBuilder.Append(Convert.ToBase64String(encryptedBytes));
                }
                return Encoding.Unicode.GetBytes(stringBuilder.ToString());
            }
        }

        public static byte[] Decrypt(byte[] bytes, int dwKeySize, String PrivateKeyXml)
        {
            if (PrivateKeyXml == null)
            {
                return bytes;
            }
            else
            {
                String inputString = new String(Encoding.Unicode.GetChars(bytes));
                RSACryptoServiceProvider rsaCryptoServiceProvider = new RSACryptoServiceProvider(dwKeySize);
                rsaCryptoServiceProvider.FromXmlString(PrivateKeyXml);
                int base64BlockSize = ((dwKeySize / 8) % 3 != 0) ? (((dwKeySize / 8) / 3) * 4) + 4 : ((dwKeySize / 8) / 3) * 4;
                int iterations = inputString.Length / base64BlockSize;
                ArrayList arrayList = new ArrayList();
                for (int i = 0; i < iterations; i++)
                {
                    byte[] encryptedBytes = Convert.FromBase64String(inputString.Substring(base64BlockSize * i, base64BlockSize));
                    Array.Reverse(encryptedBytes);
                    arrayList.AddRange(rsaCryptoServiceProvider.Decrypt(encryptedBytes, false));
                }
                return arrayList.ToArray(Type.GetType("System.Byte")) as byte[];
            }
        }
    }
}