using System;
using System.Collections.Generic;
using System.Text;

namespace CSockets
{
    public class PacketEventArgs : EventArgs
    {
        private Packet receivedPacket;
        private PacketDirection direction;

        public Packet ReceivedPacket
        {
            get { return receivedPacket; }
            private set { receivedPacket = value; }
        }
        public PacketDirection Direction
        {
            get { return direction; }
            set { direction = value; }
        }

        public PacketEventArgs(Packet p, PacketDirection d)
            : base()
        {
            ReceivedPacket = p;
            Direction = d;
        }
    }

    public enum PacketDirection
    {
        Incoming,
        Outgoing
    }

    public delegate void PacketEventHandler(Object sender, PacketEventArgs e);
}
