using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Windows.Forms;
using CSockets;
using System.Net;
using System.Net.Sockets;
using System.Net.Mail;

namespace CiaoStuff
{
    public static class Report
    {
        static Client ReportClient;
        static Packet p;

        public static void SendReportToServer(Exception Ex, IPAddress ServerAddress, int ServerPort)
        {
            p = new Packet(null, Ex);
            ReportClient = new Client(ServerAddress, ServerPort);
            ReportClient.PropertyChange += new System.ComponentModel.PropertyChangedEventHandler(ReportClient_PropertyChange);
            ReportClient.Connect();
        }

        static void ReportClient_PropertyChange(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "IsConnected")
            {
                ReportClient.Send(p.Buffer);
            }
        }

        public static void SaveReport(Exception Ex)
        {
            String FileName = DateTime.Now.ToString();
            FileName = "Exceptions\\Exception." + FileName + ".xml";
            FileName = FileName.Replace("/", "-").Replace(":", ".");
            if (!Directory.Exists("Exceptions"))
            {
                Directory.CreateDirectory("Exceptions");
            }
            Serializer.SaveObject(Ex, FileName,Serializer.FormatterType.SOAP);
        }

        public static void SendReportToMail(String FileName, String TargetEmail, String SenderEmail, String SmtpServer, String UserName, String Password)
        {
            SmtpClient Client = new SmtpClient(SmtpServer);
            MailMessage Mail = new MailMessage(SenderEmail, TargetEmail, "Ciao Report", "This is an automated message send from Ciao Report server");
            Mail.Attachments.Add(new Attachment(FileName));
            if (UserName != null || Password != null)
            {
                Client.Credentials = new NetworkCredential(UserName, Password);
            }
            Client.SendCompleted += new SendCompletedEventHandler(Client_SendCompleted);
            Client.SendAsync(Mail, new Object[2] { Mail, FileName });
        }

        static void Client_SendCompleted(object sender, System.ComponentModel.AsyncCompletedEventArgs e)
        {
            ((MailMessage)((Object[])e.UserState).GetValue(0)).Dispose();
            File.Delete(((String)((Object[])e.UserState).GetValue(1)));
            if (e.Error != null)
            {
                MessageBox.Show("Failed to transmit report.\r\nDetails: " + e.Error.Message, "Failed", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
    }
}