#ifndef _SHAREDMEMORY_H
#define	_SHAREDMEMORY_H

static char cstrSMName[] = "SharedMemory";
class CSharedMemory
{
protected:
	HANDLE	m_hSharedMemoryFile;
public:
	void *	m_pwData;
protected:
	DWORD	dwMaximumSizeHigh; 
	DWORD	dwMaximumSizeLow;
	DWORD	dwNumberOfBytesToMap;
	BOOL	m_bInit;
	BOOL	m_bAlreadyExist;

   CString csMutexName;
   HANDLE m_hMutex;

public:

   CString csName; 
public:

	void* GetData()
	{
		if( m_bInit )
			return m_pwData;
		else
			return NULL;
	}

	CSharedMemory(){m_hMutex = NULL; csName = cstrSMName;m_bInit = FALSE;m_bAlreadyExist = FALSE;csMutexName = csName + "Mutex";}
	CSharedMemory(LPCSTR cs){m_hMutex = NULL;csName = cs;m_bInit = FALSE;m_bAlreadyExist = FALSE;csMutexName = csName + "Mutex";}

	CSharedMemory(int size){m_hMutex = NULL;csName = cstrSMName;m_bAlreadyExist = FALSE;csMutexName = csName + "Mutex";Init(size);}
	CSharedMemory(LPCSTR cs, int size){m_hMutex = NULL;csName = cs;m_bAlreadyExist = FALSE;csMutexName = csName + "Mutex"; Init(size);}
	BOOL Init(LPCSTR cs, int size){csName = cs;m_bAlreadyExist = FALSE;csMutexName = csName + "Mutex"; return Init(size);}
	BOOL Init(int size ,LPCSTR cs){csName = cs;m_bAlreadyExist = FALSE;csMutexName = csName + "Mutex"; return Init(size);}
	BOOL Init( int size )
	{
      if( m_hMutex )
         CloseHandle(m_hMutex);
      m_hMutex = CreateMutex(NULL,FALSE,csMutexName);
		dwNumberOfBytesToMap = size;
		m_hSharedMemoryFile = CreateFileMapping((HANDLE)0xFFFFFFFF,
										NULL,
										PAGE_READWRITE,
										0/*dwMaximumSizeHigh*/,
										dwNumberOfBytesToMap/*dwMaximumSizeLow*/,
										csName.GetBuffer(0));
		if(m_hSharedMemoryFile == NULL)
		{
			m_bAlreadyExist = FALSE;
			m_bInit = FALSE;
			return FALSE;
		}
		else
		{
       if(GetLastError() == ERROR_ALREADY_EXISTS)
          m_bAlreadyExist = TRUE;
		}
		m_pwData = MapViewOfFile(m_hSharedMemoryFile,
								FILE_MAP_WRITE,
								0/*dwFileOffsetHigh*/,
								0/*dwFileOffsetLow*/,
								dwNumberOfBytesToMap);
		if(m_pwData == NULL)
		{
			m_bInit = FALSE;
			CloseHandle(m_hSharedMemoryFile);
         return FALSE;
		}
		else
			m_bInit = TRUE;
      return TRUE;
	}
	~CSharedMemory()
	{
		if (m_bInit)
		{
			UnmapViewOfFile(m_pwData);
			CloseHandle(m_hSharedMemoryFile);
		}
      if( m_hMutex )
         CloseHandle(m_hMutex);
	}
public:
   BOOL AlreadyExist()
   {
      return m_bAlreadyExist;
   }
   struct Locker
   {
      Locker(CSharedMemory* sm)
      {
         m_sm = sm;
         m_sm->Lock();
      }
      Locker(CSharedMemory& sm)
      {
         m_sm = &sm;
         m_sm->Lock();
      }
      ~Locker()
      {
         m_sm->Unlock();
      }
      CSharedMemory* m_sm;
   };
   BOOL Lock(DWORD dwMilliSec = INFINITE)
   {
      if( WaitForSingleObject(m_hMutex,dwMilliSec) == WAIT_OBJECT_0)
         return TRUE;
      return FALSE;
   }
   BOOL Unlock(DWORD dwMilliSec = INFINITE)
   {
      return ReleaseMutex(m_hMutex);
   }
   
};
#endif