// MailSlotDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MailSlotApp.h"
#include "MailSlotDlg.h"

#include "mailslot.h"
#include "UserList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define MAILSLOT_NOTIFY_MSG (WM_USER + 1)

const CString ENDL = "\r\n";


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// MailSlotDlg dialog
MailSlotDlg::MailSlotDlg(const CString & fromUserName, 
                         const CString & toComputerName, 
                         const CString & toUserName, 
                         CWnd* pParent)
	: CDialog(MailSlotDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_fromUserName = fromUserName;
    m_toComputerName = toComputerName;
    m_toUserName = toUserName;
    pParentWnd = pParent;
}

void MailSlotDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_MSG_HISTORY, m_msgHistory);
    DDX_Control(pDX, IDC_MSG_SEND, m_msgNew);
    DDX_Text(pDX, IDC_SEND_TO, m_toUserName);
    DDX_Text(pDX, IDC_TO_COMPUTER, m_toComputerName);
}

BEGIN_MESSAGE_MAP(MailSlotDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
    ON_BN_CLICKED(IDC_SEND_BTN, OnBnClickedSendBtn)
    ON_WM_DESTROY()
END_MESSAGE_MAP()


// MailSlotDlg message handlers

BOOL MailSlotDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
    SetWindowText("IM for " + m_fromUserName);
    UpdateData(FALSE);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void MailSlotDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void MailSlotDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR MailSlotDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void MailSlotDlg::OnBnClickedSendBtn()
{
    // update message history
    CString sendText, historyText;
    m_msgNew.GetWindowText(sendText);
    m_msgNew.SetWindowText("");
    m_msgHistory.GetWindowText(historyText);
    historyText += m_fromUserName + ":" + sendText + ENDL;
    m_msgHistory.SetWindowText(historyText);
    
    // actually send message
    MailSlotMessage msg;
    CString sendTo;
    msg.ToUserName(m_toUserName);
    msg.ToComputerName(m_toComputerName);
    msg.MsgText(sendText);
    
    pParentWnd->SendMessage(MAILSLOT_SEND_MSG, (WPARAM)&msg, 0);
}

void MailSlotDlg::AddMessageToHistory(MailSlotMessage & msg)
{
    CString historyText;
    m_msgHistory.GetWindowText(historyText);
    historyText += msg.FromUserName() + ":" + msg.MsgText() + ENDL;
    m_msgHistory.SetWindowText(historyText);    
}

void MailSlotDlg::OnDestroy()
{
    CDialog::OnDestroy();
}