#pragma once
#include "afxwin.h"
#include "mailslot.h"
#include "mailslotdlg.h"

#include <Afxtempl.h> // for carray

#define MAILSLOT_NOTIFY_MSG (WM_USER + 1)
#define MAILSLOT_SEND_MSG (WM_USER + 2)

// UserEntry
//      An entry in UserAry
struct UserEntry 
{
    CString userName;
    CString computerName;
};

// UserAry 
class UserAry : public CObject
{
public:
    DECLARE_SERIAL(UserAry);
    UserAry();
    virtual ~UserAry();
    void Serialize(CArchive & ar);
    bool Get(int index, UserEntry & entry);
    int Count();
    void Add(UserEntry & entry);
    int Find(const CString & userName);
    void Del(int index);
    bool load();
    bool store();
private:
    CArray<UserEntry, UserEntry> entries;
};


// UserList dialog
class UserList : public CDialog
{
	DECLARE_DYNAMIC(UserList)

public:
	UserList(const CString & userName, CWnd* pParent = NULL);   // standard constructor
	virtual ~UserList();

// Dialog Data
	enum { IDD = IDD_USER_LIST };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    virtual BOOL OnInitDialog();

	DECLARE_MESSAGE_MAP()
public:
    afx_msg void OnBnClickedLogout();
    afx_msg void OnLbnSelchangeUserList();
    afx_msg void OnLbnDblclkUserList();
    afx_msg void OnDestroy();

protected:
    void NotifyOtherUsers();
    void ClearList();
    void RefreshList();
    MailSlotDlg * GetDlg(const CString & toComputerName, const CString & toUserName);
    LRESULT OnMailSlotSendMsg(WPARAM w, LPARAM l);
    LRESULT OnMailSlotNotify(WPARAM w, LPARAM l);

    UserAry m_userAry;
    CListBox m_list;
    CString m_userName;
    MailSlot m_mailSlot;
    CWnd * pParentWnd;
    CMap<CString, const char*, MailSlotDlg *, MailSlotDlg *> dlgMap;

  
};
