#include <windows.h> 
#include <stdio.h>
#include <conio.h>
#include <tchar.h>

#define BUFSIZE 512
 
int _tmain(int argc, TCHAR *argv[]) {
	HANDLE hPipe;
	LPTSTR lpvMessage=TEXT("Default message from client");
	wchar_t *Message = new wchar_t[80];
	TCHAR chBuf[BUFSIZE];
	BOOL fSuccess;
	DWORD cbRead, cbWritten, dwMode;
	LPTSTR lpszPipename = TEXT("\\\\.\\pipe\\mynamedpipe");
	if( argc > 1 ) {
		lpvMessage = argv[1];
	}
	
	while (1) {
		hPipe = CreateFile (
			lpszPipename,	// pipe name
			GENERIC_READ |	// read and write access
			GENERIC_WRITE,
			0,				// no sharing
			NULL,			// default security attributes
			OPEN_EXISTING,	// opens existing pipe
			0,				// default attributes
			NULL			// no template file
			);
		
		if (hPipe != INVALID_HANDLE_VALUE) {
			break;
		}
		
		if (GetLastError() != ERROR_PIPE_BUSY) {
			printf("Could not open pipe");
			getch();
			return 0;
		}
		
		if (!WaitNamedPipe(lpszPipename, 20000)) {
			printf("Could not open pipe");
			getch();
			return 0;
		}
	}
	
	dwMode = PIPE_READMODE_MESSAGE;
	fSuccess = SetNamedPipeHandleState (
		hPipe,		// pipe handle
		&dwMode,	// new pipe mode
		NULL,		// don't set maximum bytes
		NULL		// don't set maximum time
		);

	if (!fSuccess) {
		printf("SetNamedPipeHandleState failed");
		return 0;
	}

	fSuccess = WriteFile(
		hPipe,					// pipe handle
		lpvMessage,             // message
		(lstrlen(lpvMessage)+1)*sizeof(TCHAR),	// message length
		&cbWritten,				// bytes written
		NULL);					// not overlapped
	
	if (!fSuccess) {
		printf("WriteFile failed");
		return 0;
	}
	
	do {
		fSuccess = ReadFile (
			hPipe,    // pipe handle
			chBuf,    // buffer to receive reply
			BUFSIZE*sizeof(TCHAR),  // size of buffer
			&cbRead,  // number of bytes read
			NULL      // not overlapped
			);

		if (! fSuccess && GetLastError() != ERROR_MORE_DATA) {
			break;
		}
		_tprintf( TEXT("%s\n"), chBuf );
	}
	while (!fSuccess);
	getch();
	
	CloseHandle(hPipe);
	return 0;
}